; ==========    =========
;
;     PIC16C54C 
;   PIC16F84A     MPLAB6.60  
;        
; 
;
; =================================================================

	include <P16C5X.inc>
	radix dec
	processor 16C54C
	__config _wdt_on & _rc_osc

; ------   ---------

indata equ 8
incnt equ indata+1
trisa equ incnt+1
trisb equ trisa+1

; ___ equ trisb+1

; -------   -----------

	org 2
	goto reset

	org 100

; -------  ----------

;   (indata)  .
Indikation
	movlw 8
	movwf incnt
	bsf porta,3
indik1
	bcf portb,6
	btfsc indata,7
	bsf portb,6
	bsf portb,7
	rlf indata,f
	bcf portb,7
	decfsz incnt,f
	goto indik1
	bcf porta,3
	retlw 0xFF

;     
; (Adm-, Mid-, Imp-)

X1Adm
	bcf trisb,0
	bsf trisb,1
	bsf trisb,2
	movfw trisb
	tris portb
	retlw 0xFF
X1Mid
	bsf trisb,0
	bcf trisb,1
	bsf trisb,2
	movfw trisb
	tris portb
	retlw 0xFF
X1Imp
	bsf trisb,0
	bsf trisb,1
	bcf trisb,2
	movfw trisb
	tris portb
	retlw 0xFF

X2Adm
	bcf trisb,3
	bsf trisb,4
	bsf trisb,5
	movfw trisb
	tris portb
	retlw 0xFF

X2Mid
	bsf trisb,3
	bcf trisb,4
	bsf trisb,5
	movfw trisb
	tris portb
	retlw 0xFF
X2Imp
	bsf trisb,3
	bsf trisb,4
	bcf trisb,5
	movfw trisb
	tris portb
	retlw 0xFF

X3Adm
	bcf trisa,0
	bsf trisa,1
	bsf trisa,2
	movfw trisa
	tris porta
	retlw 0xFF
X3Mid
	bsf trisa,0
	bcf trisa,1
	bsf trisa,2
	movfw trisa
	tris porta
	retlw 0xFF
X3Imp
	bsf trisa,0
	bsf trisa,1
	bcf trisa,2
	movfw trisa
	tris porta
	retlw 0xFF

;    
; (H-, L-)

X1H
	movlw B'00000111'
	iorwf portb,f
	retlw 0xFF
X1L
	movlw B'11111000'
	andwf portb,f
	retlw 0xFF
X2H
	movlw B'00111000'
	iorwf portb,f
	retlw 0xFF
X2L
	movlw B'11000111'
	andwf portb,f
	retlw 0xFF
X3H
	movlw B'00000111'
	iorwf porta,f
	retlw 0xFF
X3L
	movlw B'11111000'
	andwf porta,f
	retlw 0xFF

;     
;  -  : Z=1 - , Z=0 - 

X1
	movfw trisb
	andwf portb,w
	andlw B'00000111'
	retlw 0xFF
X2
	movfw trisb
	andwf portb,w
	andlw B'00111000'
	retlw 0xFF
X3
	movfw trisa
	andwf porta,w
	andlw B'00000111'
	retlw 0xFF

;   ( PIC16C54C)

Test_NPN_EKB goto Test_NPN_EKB_
Test_PNP_EKB goto Test_PNP_EKB_

Test_NPN_EBK goto Test_NPN_EBK_
Test_PNP_EBK goto Test_PNP_EBK_

Test_NPN_KBE goto Test_NPN_KBE_
Test_PNP_KBE goto Test_PNP_KBE_

Test_NPN_KEB goto Test_NPN_KEB_
Test_PNP_KEB goto Test_PNP_KEB_

Test_NPN_BKE goto Test_NPN_BKE_
Test_PNP_BKE goto Test_PNP_BKE_

Test_NPN_BEK goto Test_NPN_BEK_
Test_PNP_BEK goto Test_PNP_BEK_

;   .
;  -  W-:     .

Test_NPN_EKB_
	call X1Adm	;  -     
	call X1L
	call X2Mid	;  -    
	call X2H
	call X3Imp	;     
	call X3L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'81'	; , 

Test_PNP_EKB_
	call X1Adm	;  -    
	call X1H
	call X2Mid	;  -     
	call X2L
	call X3Imp	;     
	call X3L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'41'	; , 

Test_NPN_EBK_
	call X1Adm	;  -     
	call X1L
	call X3Mid	;  -    
	call X3H
	call X2Imp	;     
	call X2L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'82'	; , 

Test_PNP_EBK_
	call X1Adm	;  -    
	call X1H
	call X3Mid	;  -     
	call X3L
	call X2Imp	;     
	call X2L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'42'	; , 

Test_NPN_KBE_
	call X3Adm	;  -     
	call X3L
	call X1Mid	;  -    
	call X1H
	call X2Imp	;     
	call X2L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'84'	; , 

Test_PNP_KBE_
	call X3Adm	;  -    
	call X3H
	call X1Mid	;  -     
	call X1L
	call X2Imp	;     
	call X2L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X2H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'44'	; , 

Test_NPN_KEB_
	call X2Adm	;  -     
	call X2L
	call X1Mid	;  -    
	call X1H
	call X3Imp	;     
	call X3L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'88'	; , 

Test_PNP_KEB_
	call X2Adm	;  -    
	call X2H
	call X1Mid	;  -     
	call X1L
	call X3Imp	;     
	call X3L	;   
	call X1		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X3H	;   
	call X1		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'48'	; , 

Test_NPN_BKE_
	call X3Adm	;  -     
	call X3L
	call X2Mid	;  -    
	call X2H
	call X1Imp	;     
	call X1L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'90'	; , 

Test_PNP_BKE_
	call X3Adm	;  -    
	call X3H
	call X2Mid	;  -     
	call X2L
	call X1Imp	;     
	call X1L	;   
	call X2		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X2		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'50'	; , 

Test_NPN_BEK_
	call X2Adm	;  -     
	call X2L
	call X3Mid	;  -    
	call X3H
	call X1Imp	;     
	call X1L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'A0'	; , 

Test_PNP_BEK_
	call X2Adm	;  -    
	call X2H
	call X3Mid	;  -     
	call X3L
	call X1Imp	;     
	call X1L	;   
	call X3		;  
	btfsc status,z	; ?
	retlw 0		; , 
; , 
	call X1H	;   
	call X3		;  
	btfss status,z	; ?
	retlw 0		; , 
	retlw H'60'	; , 

; -------   ------
reset

; ------     ------

; 
	clrf porta
	clrf portb
	movlw 0
	movwf trisa
	tris porta
	movwf trisb
	tris portb
	clrwdt

; ------     ------------------
;  

; ------    -----------------
main

	clrf indata

	call Test_NPN_EKB
	iorwf indata,f

	call Test_PNP_EKB
	iorwf indata,f

	call Test_NPN_EBK
	iorwf indata,f

	call Test_PNP_EBK
	iorwf indata,f

	call Test_NPN_KBE
	iorwf indata,f

	call Test_PNP_KBE
	iorwf indata,f

	call Test_NPN_KEB
	iorwf indata,f

	call Test_PNP_KEB
	iorwf indata,f

	call Test_NPN_BKE
	iorwf indata,f

	call Test_PNP_BKE
	iorwf indata,f

	call Test_NPN_BEK
	iorwf indata,f

	call Test_PNP_BEK
	iorwf indata,f

	call Indikation

	clrwdt
	goto main


; ============  ==============
	end
